## mingw-w64-anari-sdk-0.11.1-1.src.tar.zst

=== CMakeLists.txt ===
## Copyright 2021-2024 The Khronos Group
## SPDX-License-Identifier: Apache-2.0

cmake_minimum_required(VERSION 3.11)

message(STATUS "CMake version: ${CMAKE_VERSION}")

## Language setup

set(CMAKE_DISABLE_SOURCE_CHANGES ON)
set(CMAKE_DISABLE_IN_SOURCE_BUILD ON)

set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED ON)
set(CMAKE_C_EXTENSIONS OFF)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

set(CMAKE_POSITION_INDEPENDENT_CODE ON)

set(CMAKE_BUILD_TYPE_INIT Release)

set(CMAKE_INSTALL_MESSAGE LAZY)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/cmake)

## Establish project

set(ANARI_SDK_VERSION_MAJOR 0)
set(ANARI_SDK_VERSION_MINOR 11)
set(ANARI_SDK_VERSION_PATCH 1)
set(ANARI_SDK_VERSION
  ${ANARI_SDK_VERSION_MAJOR}.${ANARI_SDK_VERSION_MINOR}.${ANARI_SDK_VERSION_PATCH}
)

project(anari VERSION ${ANARI_SDK_VERSION} LANGUAGES C CXX)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})

include(GNUInstallDirs)
include(CMakeDependentOption)

enable_testing()

if (APPLE)
  list(APPEND CMAKE_INSTALL_RPATH "@loader_path")
  list(APPEND CMAKE_INSTALL_RPATH "@loader_path/../${CMAKE_INSTALL_LIBDIR}")
elseif(UNIX)
  list(APPEND CMAKE_INSTALL_RPATH "$ORIGIN")
  list(APPEND CMAKE_INSTALL_RPATH "$ORIGIN/../${CMAKE_INSTALL_LIBDIR}")
endif()

# Built-in CMake options
option(BUILD_SHARED_LIBS "Build shared libraries instead of static" ON)
option(BUILD_TESTING "Build tests for CTest" ON)
# ANARI specific options

option(BUILD_CTS "Build cts toolkit" OFF)
cmake_dependent_option(CTS_ENABLE_GLTF "Enable glTF support for cts" ON "BUILD_CTS" OFF)
option(USE_DRACO "Use draco when loading glTF files" OFF)
option(USE_WEBP "Use webp when loading glTF files" OFF)
option(USE_KTX "Use ktx when loading glTF files" OFF)

if (CTS_ENABLE_GLTF)
    # To enforce WEBP, KTX and DRACO support (CI does not have these dependecies)
    # set(USE_KTX ON)
    # set(USE_WEBP ON)
    # set(USE_DRACO ON)
endif()

option(BUILD_EXAMPLES "Build example applications and example device" ON)
cmake_dependent_option(BUILD_VIEWER
  "Build interactive viewer app (requires GLFW)"
  OFF
  "BUILD_EXAMPLES"
  OFF
)
cmake_dependent_option(BUILD_SCENES_LIB
  "Enable anari_test_scenes library"
  ON
  "NOT BUILD_TESTING;NOT BUILD_EXAMPLES;NOT BUILD_CTS"
  ON
)
option(INSTALL_VIEWER_LIBRARY "Install anari::anari_viewer library target" ON)
option(INSTALL_VIEWER "Install anariViewer app" OFF)
mark_as_advanced(INSTALL_VIEWER)
cmake_dependent_option(VIEWER_ENABLE_GLTF
  "Enable glTF support in viewer"
  OFF
  "BUILD_VIEWER"
  OFF
)
if (VIEWER_ENABLE_GLTF)
    # To enforce WEBP and DRACO support (CI does not have these dependecies)
    # set(USE_WEBP ON)
    # set(USE_DRACO ON)
endif()
cmake_dependent_option(VIEWER_ENABLE_KTX
  "Enable KTX support in viewer"
  OFF
  "BUILD_VIEWER"
  OFF
)
if (VIEWER_ENABLE_KTX)
    set(USE_KTX ON)
endif()

## The generate_all targets collects all offline code generation targets

set(ANARI_CODE_GEN_ROOT ${CMAKE_SOURCE_DIR}/code_gen)
add_custom_target(generate_all)
include(cmake/anari_generate_frontend.cmake)
include(cmake/anari_generate_codegen.cmake)
include(cmake/cmake_project_commands.cmake)
include(cmake/anari_sdk_fetch_project.cmake)

## Add library and executable targets

add_subdirectory(src)
add_subdirectory(external)
add_subdirectory(code_gen)
if (BUILD_EXAMPLES)
  add_subdirectory(examples)
endif()

if (BUILD_TESTING)
  include(CTest)
  add_subdirectory(tests)
endif()

if (BUILD_CTS)
  add_subdirectory(cts)
endif()

include(cmake/mark_cache_variables_as_advanced.cmake)

## Configure CMake find_package() config files ##

set(ANARI_CMAKE_INSTALL_DESTINATION
  ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}-${PROJECT_VERSION}
)

install(EXPORT anari_Exports
  DESTINATION ${ANARI_CMAKE_INSTALL_DESTINATION}
  NAMESPACE anari::
)

include(CMakePackageConfigHelpers)

configure_package_config_file(
  "${PROJECT_SOURCE_DIR}/cmake/${PROJECT_NAME}Config.cmake.in"
  "${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
INSTALL_DESTINATION
  ${ANARI_CMAKE_INSTALL_DESTINATION}
)

write_basic_package_version_file(
    "${PROJECT_NAME}ConfigVersion.cmake"
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY SameMajorVersion
)

install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
DESTINATION
  ${ANARI_CMAKE_INSTALL_DESTINATION}
)

install(DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/cmake
  DESTINATION
    ${ANARI_CMAKE_INSTALL_DESTINATION}
  FILES_MATCHING
    PATTERN *.cmake
    PATTERN Findanari.cmake EXCLUDE
)

=== code_gen/CMakeLists.txt ===
## Copyright 2021-2024 The Khronos Group
## SPDX-License-Identifier: Apache-2.0

## Installation of scripts (independent of code-gen targets) ##

option(INSTALL_CODE_GEN_SCRIPTS "Install scripts in code_gen/" ON)
if (INSTALL_CODE_GEN_SCRIPTS)
  install(DIRECTORY ${CMAKE_CURRENT_LIST_DIR}
    DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/anari
    COMPONENT code_gen
    FILES_MATCHING
      PATTERN *.py
      PATTERN *.h
      PATTERN *.cpp
      PATTERN *.json
      PATTERN templates/CMakeLists.txt
      PATTERN ./CMakeLists.txt EXCLUDE
  )
endif()

## Local targets for code-gen + API bindings ##

if(CMAKE_VERSION VERSION_LESS "3.12")
  return()
endif()

find_package(Python3 OPTIONAL_COMPONENTS Interpreter Development.Module)

if (NOT TARGET Python3::Interpreter)
  message(WARNING "Unable to find python interpreter, skipping code-gen + API bindings")
  return()
endif()

option(INSTALL_PYTHON_BINDINGS "Install python bindings" OFF) # If turned on, draws in all the custom targets below (generate_all)
cmake_dependent_option(LINK_BINDINGS_TO_RELEASE_PYTHON "Force the python bindings to implicitly link to a release python library on Windows, overriding possible debug python linking" OFF INSTALL_PYTHON_BINDINGS OFF)

set(API_JSON api/anari_core_1_0.json api/khr_frame_completion_callback.json)

add_custom_target(generate_type_utility
  COMMAND ${Python3_EXECUTABLE} generate_headers.py ${CMAKE_SOURCE_DIR}/src/anari/include/anari/frontend/type_utility.h ${API_JSON}
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  DEPENDS ${API_JSON} generate_headers.py
)

add_custom_target(generate_extension_utility
  COMMAND ${Python3_EXECUTABLE} generate_extension_utility.py
  -j ${CMAKE_CURRENT_SOURCE_DIR}/api/
  -d devices/experimental_device.json
  -o ${CMAKE_SOURCE_DIR}/src/anari/include/anari/frontend
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  DEPENDS devices/experimental_device.json generate_extension_utility.py
)

add_custom_target(generate_anari_h
  COMMAND ${Python3_EXECUTABLE} generate_headers.py ${CMAKE_SOURCE_DIR}/src/anari/include/anari/anari.h ${API_JSON}
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  DEPENDS ${API_JSON} generate_headers.py
)

add_custom_target(generate_anari_enums_h
  COMMAND ${Python3_EXECUTABLE} generate_headers.py ${CMAKE_SOURCE_DIR}/src/anari/include/anari/frontend/anari_enums.h ${API_JSON}
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  DEPENDS ${API_JSON} generate_headers.py
)
add_custom_target(generate_headers DEPENDS
    generate_type_utility
    generate_extension_utility
    generate_anari_h
    generate_anari_enums_h
)

add_dependencies(generate_all generate_headers)

if (INSTALL_PYTHON_BINDINGS)
  set(BUILD_PYTHON_BINDINGS_BY_DEFAULT ALL)
endif()

if (LINK_BINDINGS_TO_RELEASE_PYTHON)
  set(LINK_BINDINGS_TO_RELEASE_PYTHON_FLAG "-R")
endif()

# Generate the C file using the Python script
add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/pyanari_bindings.c
    COMMAND ${Python3_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/pyanari_build.py
        -d ${CMAKE_CURRENT_SOURCE_DIR}/devices/generic_device.json
        -j ${CMAKE_CURRENT_SOURCE_DIR}/api/
        ${LINK_BINDINGS_TO_RELEASE_PYTHON_FLAG}
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    DEPENDS pyanari_build.py ${API_JSON} devices/generic_device.json
    COMMENT "Generating Python bindings C file"
)

# Create the Python extension module
add_library(pyanari MODULE EXCLUDE_FROM_ALL
    ${CMAKE_CURRENT_BINARY_DIR}/pyanari_bindings.c
)

# Set the output name to match Python's expectations
if (WIN32)
  set(PYTHON_OBJ_EXT .pyd)
else()
  set(PYTHON_OBJ_EXT .so)
endif()
set_target_properties(pyanari
    PROPERTIES
      PREFIX ""
      SUFFIX ${PYTHON_OBJ_EXT}
)

# Force cffi to keep the python api as usual
target_compile_definitions(pyanari PRIVATE
    _CFFI_NO_LIMITED_API
)

# Link against Python libraries and anari
target_link_libraries(pyanari PRIVATE Python3::Module anari)

# Include directories for Python and anari headers
target_include_directories(pyanari PRIVATE
    ${Python3_INCLUDE_DIRS}
    ${CMAKE_SOURCE_DIR}/src/anari/include/
    ${CMAKE_BINARY_DIR}/src/anari/include/anari/
)

# Add the custom target for Python bindings
add_custom_target(python_bindings ${BUILD_PYTHON_BINDINGS_BY_DEFAULT}
    DEPENDS pyanari
)

if (INSTALL_PYTHON_BINDINGS)
  install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/anari.py
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/python_bindings)
  install(TARGETS pyanari
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}/python_bindings
    RUNTIME DESTINATION ${CMAKE_INSTALL_LIBDIR}/python_bindings)
endif()

=== cts/CMakeLists.txt ===
## Copyright 2022-2024 The Khronos Group
## SPDX-License-Identifier: Apache-2.0

cmake_minimum_required(VERSION 3.1)

# Fix "DOWNLOAD_EXTRACT_TIMESTAMP" warning
if (CMAKE_VERSION VERSION_GREATER_EQUAL "3.24.0")
  cmake_policy(SET CMP0135 NEW)
endif()

if (TARGET anari)
  list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/../cmake)
endif()

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

set(REFERENCE_LIB helide)

project(anariCTSBackend LANGUAGES CXX)

set(Python3_ROOT_DIR "" CACHE PATH "Path to python3 directory")
set(Python3_FIND_REGISTRY "LAST")
set(Python3_FIND_STRATEGY "LOCATION")
find_package(anari REQUIRED)
find_package(Python3 3.9...<3.20 REQUIRED COMPONENTS Interpreter Development)
message("CTS Python version: ${Python3_VERSION}\nCTS Python Path: ${Python3_EXECUTABLE}")
include(pybind11.cmake)

pybind11_add_module(${PROJECT_NAME}
  src/anariInfo.cpp
  src/anariWrapper.cpp
  src/ctsQueries.cpp
  src/main.cpp
  src/PrimitiveGenerator.cpp
  src/SceneGenerator.cpp
  src/ColorPalette.cpp
  src/TextureGenerator.cpp
)

target_include_directories(${PROJECT_NAME}
PUBLIC
  ${CMAKE_CURRENT_LIST_DIR}/header
)

target_link_libraries(${PROJECT_NAME} PUBLIC helium anari_test_scenes)

file(GLOB python_files ${CMAKE_CURRENT_LIST_DIR}/*.py)

add_subdirectory(src) # query generation target

add_custom_target(generate_cts_baseline
  COMMAND ${Python3_EXECUTABLE} ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/createReferenceData.py
	  --test_scenes ${CMAKE_CURRENT_LIST_DIR}/test_scenes -l ${REFERENCE_LIB}
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)
add_dependencies(generate_cts_baseline ${PROJECT_NAME})

add_custom_target(generate_cts)
add_dependencies(generate_cts generate_cts_queries generate_cts_baseline)
add_dependencies(generate_all generate_cts)

option(CTS_DEV "Copy compiled python module next to python script to make developing easier" OFF)
mark_as_advanced(CTS_DEV)
if (CTS_DEV AND NOT BUILD_SHARED_LIBS)
  add_custom_command(TARGET ${PROJECT_NAME}
    COMMAND ${CMAKE_COMMAND}
        -DBUILD_CONFIG_DIR=${CMAKE_CFG_INTDIR}
        -DCMAKE_RUNTIME_OUTPUT_DIRECTORY=${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
        -DREFERENCE_LIB=${REFERENCE_LIB}
    -P "${CMAKE_CURRENT_LIST_DIR}/copy_post_build.cmake"
    VERBATIM
  )
endif()

anari_sdk_fetch_project(
  NAME anari_cts_glTFSampleAssets
  URL https://github.com/KhronosGroup/glTF-Sample-Assets/archive/754a32a333b27698b6c36d8bec8ff7ed5f729538.zip
  MD5 1250786407d1d0e649faaade748c24ab
)

message("Copying glTF Sample Models")
file(GLOB GLTF_SAMPLE_ASSETS_FILES ${anari_cts_glTFSampleAssets_LOCATION}/Models/*)
list(FILTER GLTF_SAMPLE_ASSETS_FILES EXCLUDE REGEX ".*Unicode❤♻Test")
file(COPY ${GLTF_SAMPLE_ASSETS_FILES} DESTINATION ${CMAKE_CURRENT_LIST_DIR}/gltf-Sample-Assets)

## Installation ##

# .pyd files are considered library files
if (WIN32)
  install(TARGETS ${PROJECT_NAME}
    LIBRARY DESTINATION ${CMAKE_INSTALL_BINDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  )
else()
  install(TARGETS ${PROJECT_NAME}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  )
endif()

install(FILES ${python_files} ${CMAKE_CURRENT_LIST_DIR}/default_test_scene.json
  ${CMAKE_CURRENT_LIST_DIR}/pyproject.toml
  ${CMAKE_CURRENT_LIST_DIR}/poetry.lock
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/anari/cts
)

install(DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/test_scenes
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/anari/cts
)

install(DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/gltf-Sample-Assets
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/anari/cts
)

=== src/CMakeLists.txt ===
## Copyright 2021-2024 The Khronos Group
## SPDX-License-Identifier: Apache-2.0

add_subdirectory(anari)
add_subdirectory(anari_viewer)
add_subdirectory(helium)
add_subdirectory(debug_device)
add_subdirectory(sink_device)

option(BUILD_HELIDE_DEVICE "Build example 'helide' device" ON)
if (BUILD_HELIDE_DEVICE)
  add_subdirectory(helide)
endif()

if(BUILD_SCENES_LIB)
  add_subdirectory(anari_test_scenes)
endif()

option(BUILD_REMOTE_DEVICE "Build 'remote' TCP passthrough device" OFF)
if (BUILD_REMOTE_DEVICE)
  add_subdirectory(remote_device)
endif()

option(BUILD_HDANARI "Build OpenUSD Hydra delegate plugin" OFF)
if (BUILD_HDANARI)
  add_subdirectory(hdanari)
endif()

=== code_gen/templates/CMakeLists.txt ===
## This file was generated by $generator from $template

set(CMAKE_CXX_STANDARD 11)

project(anari_library_$libraryname LANGUAGES CXX)

if(CMAKE_VERSION VERSION_GREATER_EQUAL "3.12")
  find_package(Python3 REQUIRED COMPONENTS Interpreter)

  add_custom_target(generate_$libraryname_queries
    COMMAND ${Python3_EXECUTABLE} ${ANARI_CODE_GEN_ROOT}/generate_queries.py
      --json ${ANARI_CODE_GEN_ROOT}
      --prefix $prefix
      --device ${CMAKE_CURRENT_SOURCE_DIR}/$device_json
      --namespace $namespace
      --output ${CMAKE_CURRENT_SOURCE_DIR}/generated
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    DEPENDS $device_json
  )

  add_dependencies(generate_all generate_$libraryname_queries)
endif()

set(CMAKE_INSTALL_RPATH "$ORIGIN")

add_library(${PROJECT_NAME} SHARED
  $source_path/$prefixDevice.cpp
  $source_path/$prefixArrayObjects.cpp
  $source_path/$prefixFrameObject.cpp
  $source_path/$prefixDeviceObject.cpp
  $generated_path/$prefixObjects.cpp
  $generated_path/$prefixDeviceFactories.cpp
  $generated_path/$prefixString.cpp
  $generated_path/$prefixQueries.cpp
)

target_include_directories(${PROJECT_NAME}
PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}>
  $source_path
  $generated_path
)

target_link_libraries(${PROJECT_NAME}
PUBLIC
  $target_prefixanari
  $target_prefixanari_utilities
)

target_compile_definitions(${PROJECT_NAME}
PRIVATE
  "anari_library_$libraryname_EXPORTS"
)

install(TARGETS ${PROJECT_NAME}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

=== cts/src/CMakeLists.txt ===
## Copyright 2022-2024 The Khronos Group
## SPDX-License-Identifier: Apache-2.0

anari_generate_queries(
  NAME cts_queries
  PREFIX cts
  CPP_NAMESPACE cts
  JSON_DEFINITIONS_FILE ${ANARI_CODE_GEN_ROOT}/devices/experimental_device.json
)

=== examples/empty_helium_device/CMakeLists.txt ===
## Copyright 2024 The Khronos Group
## SPDX-License-Identifier: Apache-2.0

cmake_minimum_required(VERSION 3.11)

if (${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_CURRENT_LIST_DIR})
  set(STANDALONE_SOURCE_TREE TRUE)
else()
  set(STANDALONE_SOURCE_TREE FALSE)
endif()

if (STANDALONE_SOURCE_TREE)
  message(STATUS "CMake version: ${CMAKE_VERSION}")
endif()

## Language setup ##

set(CMAKE_DISABLE_SOURCE_CHANGES ON)
set(CMAKE_DISABLE_IN_SOURCE_BUILD ON)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

set(CMAKE_POSITION_INDEPENDENT_CODE ON)

set(CMAKE_BUILD_TYPE_INIT Release)

set(CMAKE_INSTALL_RPATH "$ORIGIN")
set(CMAKE_INSTALL_MESSAGE LAZY)

## Establish project ##

project(anari_library_hecore LANGUAGES CXX)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

include(GNUInstallDirs)

## Dependencies ##

find_package(anari REQUIRED)

## Code generation ##

anari_generate_queries(
  NAME hecore_queries
  PREFIX HeCoreDevice
  CPP_NAMESPACE hecore
  JSON_DEFINITIONS_FILE ${CMAKE_CURRENT_SOURCE_DIR}/HeCoreDefinitions.json
)
if (TARGET generate_all AND TARGET generate_hecore_queries)
  add_dependencies(generate_all generate_hecore_queries)
endif()

## Build device target ##

add_library(${PROJECT_NAME} SHARED
  HeCoreDevice.cpp
  HeCoreDeviceQueries.cpp
  HeCoreDeviceGlobalState.cpp
  HeCoreLibrary.cpp
  Object.cpp
  camera/Camera.cpp
  frame/Frame.cpp
  renderer/Renderer.cpp
  scene/Group.cpp
  scene/Instance.cpp
  scene/World.cpp
  scene/light/Light.cpp
  scene/surface/Surface.cpp
  scene/surface/geometry/Geometry.cpp
  scene/surface/material/Material.cpp
  scene/surface/material/sampler/Sampler.cpp
  scene/volume/Volume.cpp
  scene/volume/spatial_field/SpatialField.cpp
)

target_link_libraries(${PROJECT_NAME} PRIVATE anari::helium)

include(GenerateExportHeader)
generate_export_header(${PROJECT_NAME} EXPORT_MACRO_NAME "HECORE_EXPORT")

target_include_directories(${PROJECT_NAME}
PRIVATE
  $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}>
  $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
)

## Installation ##

install(TARGETS ${PROJECT_NAME}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

=== examples/simple/CMakeLists.txt ===
## Copyright 2021-2024 The Khronos Group
## SPDX-License-Identifier: Apache-2.0

cmake_minimum_required(VERSION 3.11)

message(STATUS "CMake version: ${CMAKE_VERSION}")

if (${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_CURRENT_SOURCE_DIR})
  set(IN_SDK_SOURCE_TREE FALSE)
else()
  set(IN_SDK_SOURCE_TREE TRUE)
endif()

## Language setup

set(CMAKE_DISABLE_SOURCE_CHANGES ON)
set(CMAKE_DISABLE_IN_SOURCE_BUILD ON)

set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED ON)
set(CMAKE_C_EXTENSIONS OFF)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

set(CMAKE_POSITION_INDEPENDENT_CODE ON)

set(CMAKE_BUILD_TYPE_INIT Release)

set(CMAKE_INSTALL_MESSAGE LAZY)

## Establish project

project(anari_examples LANGUAGES C CXX)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

include(GNUInstallDirs)

## Dependencies

find_package(anari REQUIRED)

if (NOT IN_SDK_SOURCE_TREE)
  add_subdirectory(${CMAKE_CURRENT_LIST_DIR}/../../external/stb_image stb_image)
endif()

## Example apps

add_executable(anariTutorial anariTutorial.c)
target_link_libraries(anariTutorial PRIVATE anari::anari stb_image)

add_executable(anariTutorialCpp anariTutorial.cpp)
target_link_libraries(anariTutorialCpp PRIVATE anari::anari stb_image)

add_executable(anariTutorialDebug anariTutorialDebug.c)
target_link_libraries(anariTutorialDebug PRIVATE anari::anari stb_image)

add_executable(anariTutorialInitFromEnv anariTutorialInitFromEnv.c)
target_link_libraries(anariTutorialInitFromEnv PRIVATE anari::anari)

add_executable(anariInfo anariInfo.cpp)
target_link_libraries(anariInfo PRIVATE anari::anari_static)

option(USE_MPI "Enable MPI and Distributed Tutorial")
if (USE_MPI)
  find_package(MPI REQUIRED)
  add_executable(anariDistributedTutorial anariDistributedTutorial.cpp)
  target_link_libraries(anariDistributedTutorial PRIVATE anari::anari stb_image MPI::MPI_CXX)
endif()

if (IN_SDK_SOURCE_TREE)
  install(TARGETS anariInfo RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

  if (TARGET anari_library_helide)
    # This app links to the include 'helide' device library directly to use its
    # direct device creation function. Vendors can choose to ship a header with
    # such a direct function in it.
    add_executable(anariTutorialDirectLink anariTutorialDirectLink.c)
    target_link_libraries(anariTutorialDirectLink PRIVATE anari_library_helide)
  endif()

  if (BUILD_TESTING)
    add_test(NAME anariTutorial COMMAND anariTutorial)
    add_test(NAME anariTutorialCpp COMMAND anariTutorialCpp)
    add_test(NAME anariTutorialDebug COMMAND anariTutorialDebug)
  endif()
endif()

=== examples/viewer/CMakeLists.txt ===
## Copyright 2023-2024 The Khronos Group
## SPDX-License-Identifier: Apache-2.0

cmake_minimum_required(VERSION 3.11)

project(anariViewer LANGUAGES C CXX)

if (NOT TARGET anari::anari)
  find_package(anari REQUIRED COMPONENTS viewer)
endif()

project_add_executable(main.cpp ui_layout.cpp)
project_link_libraries(PRIVATE anari::anari_viewer)

if (INSTALL_VIEWER)
  install(TARGETS ${PROJECT_NAME} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

=== external/stb_image/CMakeLists.txt ===
## Copyright 2021-2024 The Khronos Group
## SPDX-License-Identifier: Apache-2.0

if (TARGET stb_image)
  return()
endif()

add_library(stb_image STATIC stb_image_write.c stb_image.c)
target_include_directories(stb_image INTERFACE ${CMAKE_CURRENT_LIST_DIR})

=== src/anari/CMakeLists.txt ===
## Copyright 2021-2024 The Khronos Group
## SPDX-License-Identifier: Apache-2.0

option(ANARI_FRONTEND_CATCH_EXCEPTIONS "Have libanari catch all exceptions" ON)
mark_as_advanced(ANARI_FRONTEND_CATCH_EXCEPTIONS)

# Some platforms simply don't function without linking against Threads::Threads
set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)

macro(add_anari_frontend_library_target LIB_TYPE)
  project_add_library(${LIB_TYPE}
    anari_cpp_linalg_defs.cpp
    anari_cpp_std_defs.cpp
    API.cpp
    DeviceImpl.cpp
    LibraryImpl.cpp
    test_c_header_compilation.c
  )

  if (WIN32)
    project_compile_definitions(PUBLIC -D_USE_MATH_DEFINES)
  endif()

  if (ANARI_FRONTEND_CATCH_EXCEPTIONS)
    project_compile_definitions(PRIVATE -DANARI_FRONTEND_CATCH_EXCEPTIONS)
  endif()

  project_include_directories(
  PUBLIC
    $<BUILD_INTERFACE:${GENERATED_HEADER_DIR}>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/include/anari>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/include>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
  )

  project_link_libraries(PUBLIC Threads::Threads ${CMAKE_DL_LIBS})

  set_target_properties(${PROJECT_NAME}
    PROPERTIES
      VERSION ${ANARI_SDK_VERSION}
      SOVERSION ${ANARI_SDK_VERSION_MAJOR}
  )

  install(TARGETS ${PROJECT_NAME}
    EXPORT anari_Exports
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
      NAMELINK_SKIP
    # on Windows put the dlls into bin
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    # ... and the import lib into the devel package
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  )

  install(TARGETS ${PROJECT_NAME}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
      NAMELINK_ONLY
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  )
endmacro()

## Create shared + static frontend library targets ##

add_anari_frontend_library_target(SHARED)

project(anari_static VERSION ${ANARI_SDK_VERSION} LANGUAGES C CXX)
add_anari_frontend_library_target(STATIC)
project_compile_definitions(PUBLIC -DANARI_STATIC_DEFINE)

## Create version header ##

configure_file(anari_sdk_version.h.in include/anari/frontend/anari_sdk_version.h)

## Install headers ##

install(
  DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/include/anari
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/include/anari/frontend/anari_sdk_version.h
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/anari/frontend
)

=== src/anari_test_scenes/CMakeLists.txt ===
## Copyright 2021-2024 The Khronos Group
## SPDX-License-Identifier: Apache-2.0

project(anari_test_scenes LANGUAGES C CXX)

project_add_library()
project_sources(PRIVATE
  anari_test_scenes.cpp

  scenes/scene.cpp

  scenes/demo/cornell_box.cpp
  scenes/demo/gravity_spheres_volume.cpp

  scenes/file/obj.cpp

  scenes/test/attributes.cpp
  scenes/test/instanced_cubes.cpp
  scenes/test/pbr_spheres.cpp
  scenes/test/random_cylinders.cpp
  scenes/test/random_spheres.cpp
  scenes/test/textured_cube.cpp
)

project_include_directories(
PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
  $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/anari/anari_test_scenes>
)
project_link_libraries(PUBLIC helium PUBLIC $<BUILD_INTERFACE:stb_image>)
project_link_libraries(PUBLIC helium PUBLIC $<BUILD_INTERFACE:mikktspace>)

if (VIEWER_ENABLE_GLTF)
  project_sources(PRIVATE scenes/file/glTF.cpp)
  project_compile_definitions(PRIVATE ENABLE_GLTF=1)
endif()

if (USE_DRACO)
  find_package(draco REQUIRED)
  project_link_libraries(PUBLIC draco::draco)
  project_compile_definitions(PUBLIC -DUSE_DRACO)
endif()

if (USE_WEBP)
  find_package(WebP REQUIRED)
  project_link_libraries(PUBLIC WebP::webp)
  project_compile_definitions(PUBLIC -DUSE_WEBP)
endif()

if (USE_KTX)
  find_package(Ktx REQUIRED)
  project_link_libraries(PUBLIC KTX::ktx)
  project_compile_definitions(PUBLIC -DUSE_KTX)
endif()

include(GenerateExportHeader)
generate_export_header(${PROJECT_NAME}
  EXPORT_MACRO_NAME "ANARI_TEST_SCENES_INTERFACE"
)

## Installation ##

install(TARGETS ${PROJECT_NAME}
  EXPORT anari_Exports
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(
FILES
  ${PROJECT_BINARY_DIR}/${PROJECT_NAME}_export.h
  ${CMAKE_CURRENT_LIST_DIR}/anari_test_scenes.h
  ${CMAKE_CURRENT_LIST_DIR}/scenes/scene.h
DESTINATION
  ${CMAKE_INSTALL_INCLUDEDIR}/anari/anari_test_scenes
)

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=anari-sdk
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=0.11.1
pkgrel=1
pkgdesc="ANARI Software Development Kit (SDK) (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64' 'clang64' 'clangarm64')
url='https://github.com/KhronosGroup/ANARI-SDK'
license=('spdx:Apache-2.0')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-python")
source=("https://github.com/KhronosGroup/ANARI-SDK/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz")
sha256sums=('164fb5b467732ac292e1363e8b47c1382df70f9080dd5ecf06011cf1d0328035')

build() {
  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    cmake -Wno-dev \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${extra_config[@]}" \
      -DBUILD_SHARED_LIBS=ON \
      -DBUILD_HELIDE_DEVICE=OFF \
      -DBUILD_SCENES_LIB=OFF \
      -DBUILD_EXAMPLES=OFF \
      -DBUILD_TESTING=OFF \
      -DINSTALL_VIEWER_LIBRARY=OFF \
      -DPython3_EXECUTABLE=${MINGW_PREFIX}/bin/python \
      -S "ANARI-SDK-${pkgver}" \
      -B "build-${MSYSTEM}"

  cmake --build "build-${MSYSTEM}"
}

check() {
  cmake -DBUILD_EXAMPLES=ON -DBUILD_TESTING=ON -S "ANARI-SDK-${pkgver}" -B "build-${MSYSTEM}"
  cmake --build "build-${MSYSTEM}"
  ctest --test-dir "build-${MSYSTEM}" --output-on-failure || true
}

package() {
  DESTDIR="${pkgdir}" cmake --install "build-${MSYSTEM}"

  MSYS2_ARG_CONV_EXCL="-p" \
    python -m compileall -o 0 -o 1 -q -s"${pkgdir}" -p"/" "${pkgdir}"${MINGW_PREFIX}

  install -Dm644 "${srcdir}"/ANARI-SDK-${pkgver}/LICENSE \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}
